string[] pocetak = Console.ReadLine().Split();
string[] unosbrojevi = Console.ReadLine().Split();
int[] brojevi = new int[int.Parse(pocetak[1])];
string resenja = "";
for (int i = 0; i < int.Parse(pocetak[1]); i++)
{
    int k = 1;
    brojevi[i] = int.Parse(unosbrojevi[i]);
    for (int j = 2; j <= brojevi[i]; j++)
    {
        if (brojevi[i] % j == 0)
        {
            k = k ^ j;
        }
    }
    if (i == int.Parse(pocetak[1]) - 1)
    {
        resenja = resenja + k.ToString();
    }
    else
    {
        resenja = resenja + k.ToString() + " ";
    }
}
Console.WriteLine(resenja);